﻿package com.kampei.image
{
	import flash.geom.Rectangle;
	
	dynamic public class BoundsArray extends Array
	{
		public function BoundsArray(numElements:int=0)
		{
			super(numElements);
		}
		
		AS3 override function push(... args):uint
		{
		    for (var i:uint = 0; i < args.length; i++)
		    {
		        if(args[i] is Bounds){
		        	super.push(args[i]);
		        } else
		        if(args[i] is Rectangle){
		        	var rect:Rectangle = args[i];
		        	var bnds:Bounds = new Bounds();
		        	bnds.x = rect.x
		        	bnds.y = rect.y
		        	bnds.width = rect.width;
		        	bnds.height = rect.height;
					super.push(bnds);
		        } else {
		        	trace("BoundsArray warning: it's not Rectangle!");
		        }
		    }
		    return this.length;
		}
		
		AS3 override function unshift(... args):uint
		{
		    for (var i:uint = 0; i < args.length; i++)
		    {
		        if(args[i] is Bounds){
		        	super.unshift(args[i]);
		        } else
		        if(args[i] is Rectangle){
		        	var rect:Rectangle = args[i];
		        	var bnds:Bounds = new Bounds();
		        	bnds.x = rect.x
		        	bnds.y = rect.y
		        	bnds.width = rect.width;
		        	bnds.height = rect.height;
					super.unshift(bnds);
		        } else {
		        	trace("BoundsArray warning: it's not Rectangle!");
		        }
		    }
		    return this.length;
		}
	}
}