﻿package com.kampei.image
{
	import flash.events.Event;
	import flash.geom.Rectangle;

	public class MotionDetectEvent extends Event
	{
		public static const UPDATE:String = "update";
		public static const CREATE:String = "create";
		public static const STAY:String = "stay";
		public static const MOVE:String = "move";
		public static const DISAPPEAR:String = "disappear";
		public static const INTEGRATE:String = "integrate";
		
		private var _id:int;
		private var _targetRect:Rectangle;
		
		public function MotionDetectEvent(type:String, bubbles:Boolean=false, cancelable:Boolean=false)
		{
			super(type, bubbles, cancelable);
		}
		
		public function get id():int
		{
			return _id;
		}
		
		public function set id(i:int):void
		{
			_id = i;
		}
		
		public function get targetRect():Rectangle
		{
			return _targetRect;
		}
		
		public function set targetRect(rect:Rectangle):void
		{
			_targetRect = rect.clone();
		}
		
		public override function clone():Event {
			var event:Event = new MotionDetectEvent(type);
			return event;
		}
	}
}